<?php



/* www
 * Protx VSP (www.protx.com)
 */

	$is_admin_path = true;
	$root_folder_path = "../";

	include_once($root_folder_path ."includes/common.php");
	include_once($root_folder_path ."includes/date_functions.php");
	include_once($root_folder_path ."messages/".$language_code."/cart_messages.php");
	
	$status_error = "";
	
	$MD    = get_param("MD");
	$PARes = get_param("PARes");
	
	if(!strlen($MD)){
		echo "Empty response from ProTX.";
		exit;
	}

	$sql  = " SELECT payment_id FROM " . $table_prefix . "payment_systems ";
	$sql .= " WHERE advanced_php_lib LIKE '%protx_direct.php'";
	$payment_id = get_db_value($sql);

	$sql  = " SELECT failure_action FROM " . $table_prefix . "payment_systems ";
	$sql .= " WHERE advanced_php_lib LIKE '%protx_direct.php'";
	$failure_action = get_db_value($sql);

	if(!strlen($payment_id)){
		echo "It is impossible to receive payment_id, please check your payment settings.";
		exit;
	}

	$variables = array();
	$sql  = " SELECT success_status_id, pending_status_id, failure_status_id FROM " . $table_prefix . "payment_systems ";
	$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$variables['success_status_id'] = trim($db->f("success_status_id"));
		$variables['pending_status_id'] = trim($db->f("pending_status_id"));
		$variables['failure_status_id'] = trim($db->f("failure_status_id"));
	}

	$payment_parameters = array();
	$sql  = " SELECT parameter_name, parameter_source, not_passed ";
	$sql .= " FROM " . $table_prefix . "payment_parameters ";
	$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
	$db->query($sql);
	while ($db->next_record()) {
		$parameter_name = trim($db->f("parameter_name"));
		$parameter_source = trim($db->f("parameter_source"));
		$payment_parameters[$parameter_name] = $parameter_source;
	}
	$CallbackURL = (isset($payment_parameters['CallbackURL'])) ?$payment_parameters['CallbackURL']:'https://ukvps.protx.com/vspgateway/service/direct3dcallback.vsp';

	$ch = curl_init();
	if ($ch){
		$post_params = "MD=" . urlencode($MD)."PARes&=" . urlencode($PARes);
		curl_setopt ($ch, CURLOPT_URL, $CallbackURL);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt ($ch, CURLOPT_HEADER, 0);
		curl_setopt ($ch, CURLOPT_POST, 1);
		curl_setopt ($ch, CURLOPT_POSTFIELDS, $post_params);
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt ($ch, CURLOPT_TIMEOUT,30);
		set_curl_options ($ch, $payment_parameters);
		$payment_response = curl_exec($ch);
		if (curl_error($ch)) {
			echo curl_error($ch);
			exit;
		}
		curl_close($ch);
		$payment_response = trim(strip_tags($payment_response));
		echo htmlspecialchars($payment_response);
	}else{
		echo "Can't initialize cURL.";
		exit;
	}

	if (!strlen($paypal_response)) {
		echo "Empty response from ProTX, please check your payment settings.";
		exit;
	}

	$response_parameters = array();
	$response_parts = explode(chr(10), $payment_response);
	if (sizeof($response_parts) == 1) {
		echo "Bad response from gateway: " . $payment_response;
		exit;
	} else {
		for($i = 0; $i < sizeof($response_parts); $i++) {
			$response_part = explode('=', $response_parts[$i], 2);
			$response_parameters[trim($response_part[0])] = urldecode(trim($response_part[1]));
			$response_parameters[strtolower(trim($response_part[0]))] = urldecode(trim($response_part[1]));
		}
	}

	$VendorTxCode = isset($response_parameters["VendorTxCode"]) ? $response_parameters["VendorTxCode"] : "";
	$VPSTxId = isset($response_parameters["VPSTxId"]) ? $response_parameters["VPSTxId"] : "";
	$SecurityKey = isset($response_parameters["SecurityKey"]) ? $response_parameters["SecurityKey"] : "";
	$TxAuthNo = isset($response_parameters["TxAuthNo"]) ? $response_parameters["TxAuthNo"] : "";
	$Status = isset($response_parameters["Status"]) ? $response_parameters["Status"] : "";
	$StatusDetail = isset($response_parameters["StatusDetail"]) ? $response_parameters["StatusDetail"] : "";
	$AVSCV2 = isset($response_parameters["AVSCV2"]) ? $response_parameters["AVSCV2"] : "";
	$AddressResult = isset($response_parameters["AddressResult"]) ? $response_parameters["AddressResult"] : "";
	$PostCodeResult = isset($response_parameters["PostCodeResult"]) ? $response_parameters["PostCodeResult"] : "";
	$CV2Result = isset($response_parameters["CV2Result"]) ? $response_parameters["CV2Result"] : "";
	$D3SecureStatus = isset($response_parameters["3DSecureStatus"]) ? $response_parameters["3DSecureStatus"] : "";
	$CAVV = isset($response_parameters["CAVV"]) ? $response_parameters["CAVV"] : "";

	$sql  = " SELECT parameter_source FROM " . $table_prefix . "payment_parameters ";
	$sql .= " WHERE payment_id=".$db->tosql($payment_id, INTEGER)." and parameter_name='VendorTxCode'";
	$VendorTxCode_mask = get_db_value($sql);

   	$prefix_length = strpos($VendorTxCode_mask, "{order_id}");
   	$order_id_length = strlen($VendorTxCode) - strlen($VendorTxCode_mask) + strlen("{order_id}");
   	$order_id = substr($VendorTxCode, $prefix_length, $order_id_length);

	$transaction_id = (strlen($VPSTxId)) ? "VPSTxId=".$VPSTxId : "";
	$transaction_id .= (strlen($VPSTxId)) ? " SecurityKey=".$SecurityKey : "";
	$error_message = '';
	if (($Status == 'OK') && (strlen($VPSTxId))) {
		$order_status = $variables['success_status_id'];
	} else {
		$order_status = $variables['failure_status_id'];
		$error_message .=(strlen($StatusDetail)) ? $StatusDetail : 'Transaction could not be authorised';
	}

	$sql  = " UPDATE " . $table_prefix . "orders ";
	$sql .= " SET authorization_code=" . $db->tosql($TxAuthNo, TEXT);
	$sql .= ", avs_message=" . $db->tosql($AVSCV2, TEXT);
	$sql .= ", avs_address_match=" . $db->tosql($AddressResult, TEXT);
	$sql .= ", avs_zip_match=" . $db->tosql($PostCodeResult, TEXT);
	$sql .= ", cvv2_match=" . $db->tosql($CV2Result, TEXT);
	$sql .= ", secure_3d_status=" . $db->tosql($D3SecureStatus, TEXT);
	$sql .= ", secure_3d_cavv=" . $db->tosql($CAVV, TEXT);
	$sql .= ", transaction_id=" . $db->tosql($transaction_id, TEXT);
	$sql .= ", error_message=" . $db->tosql($error_message, TEXT);
	$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
	$db->query($sql);

	update_order_status($order_id, $order_status, true, "", $status_error);

	if (($Status == 'OK') && (strlen($VPSTxId))) {
		header("Location: ".$root_folder_path."order_final.php");
		exit;
	} else {
		if ($failure_action == 1){
			header("Location: ".$root_folder_path."credit_card_info.php?payment_error=1");
			exit;
		} else {
			header("Location: ".$root_folder_path."order_final.php");
			exit;
		}
	}
?>